/***
 * Excerpted from "Modern Systems Programming with Scala Native",
 * published by The Pragmatic Bookshelf.
 * Copyrights apply to this code. It may not be used to create training material,
 * courses, books, articles, and the like. Contact us if you are in doubt.
 * We make no guarantees that this code is fit for any purpose.
 * Visit http://www.pragmaticprogrammer.com/titles/rwscala for more book information.
***/
import scala.scalanative.unsafe._
import scala.scalanative.libc._

object Main {
  def main(args:Array[String]):Unit = {
    val line_in_buffer = stackalloc[Byte](1024)
    while (stdio.fgets(line_in_buffer, 1023, stdio.stdin) != null) {
      parse_int_line(line_in_buffer)
    }
    println("done")
  }

  def parse_int_line(line:CString):Int = {
    val int_pointer:Ptr[Int] = stackalloc[Int]
    val scan_result = stdio.sscanf(line, c"%d\n", int_pointer)
    if (scan_result == 0) {
      throw new Exception("parse error in sscanf")
    }
    stdio.printf(c"read value %d into address %p\n", 
      !int_pointer, int_pointer)
    val int_value:Int = !int_pointer

    return int_value
  }
}